---
title: 'TypeError: invalid ''instanceof'' operand ''x'''
slug: Web/JavaScript/Reference/Errors/invalid_right_hand_side_instanceof_operand
tags:
  - Error
  - Errors
  - JavaScript
  - Reference
  - TypeError
---
<div>{{jsSidebar("Errors")}}</div>

<p>The JavaScript exception "invalid 'instanceof' operand" occurs when the right hand side operands of the <a href="/en-US/docs/Web/JavaScript/Reference/Operators/instanceof"><code>instanceof</code> operator</a> isn't used with a constructor object, i.e. an object which has a <code>prototype</code> property and is callable.</p>

<h2 id="Message">Message</h2>

<pre class="syntaxbox">TypeError: invalid 'instanceof' operand "x" (Firefox)
TypeError: "x" is not a function (Firefox)
TypeError: Right-hand side of 'instanceof' is not an object (Chrome)
TypeError: Right-hand side of 'instanceof' is not callable (Chrome)</pre>

<h2 id="Error_type">Error type</h2>

<p>{{jsxref("TypeError")}}</p>

<h2 id="What_went_wrong">What went wrong?</h2>

<p>The <a href="/en-US/docs/Web/JavaScript/Reference/Operators/instanceof"><code>instanceof</code> operator</a> expects the right hand side operands to be a constructor object, i.e. an object which has a <code>prototype</code> property and is callable.</p>

<h2 id="Examples">Examples</h2>

<h3 id="instanceof_vs_typeof">instanceof vs typeof</h3>

<pre class="brush: js example-bad">"test" instanceof ""; // TypeError: invalid 'instanceof' operand ""
42 instanceof 0;      // TypeError: invalid 'instanceof' operand 0

function Foo() {}
var f = Foo();        // Foo() is called and returns undefined
var x = new Foo();

x instanceof f;       // TypeError: invalid 'instanceof' operand f
x instanceof x;       // TypeError: x is not a function
</pre>

<p>To fix these errors, you will either need to replace the <a href="/en-US/docs/Web/JavaScript/Reference/Operators/instanceof"><code>instanceof</code> operator</a> with the <a href="/en-US/docs/Web/JavaScript/Reference/Operators/typeof"><code>typeof</code> operator</a>, or to make sure you use the function name, instead of the result of its evaluation.</p>

<pre class="brush: js example-good">typeof "test" == "string"; // true
typeof 42 == "number"      // true

function Foo() {}
var f = Foo;               // Do not call Foo.
var x = new Foo();

x instanceof f;            // true
x instanceof Foo;          // true
</pre>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Operators/instanceof"><code>instanceof</code> operator</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Operators/typeof"><code>typeof</code> operator</a></li>
</ul>
